VERSION 5.00
Begin VB.Form frmDDE 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "HomeVision DDE Example"
   ClientHeight    =   6465
   ClientLeft      =   1575
   ClientTop       =   1485
   ClientWidth     =   6000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   6465
   ScaleWidth      =   6000
   Begin VB.Frame Frame2 
      Caption         =   "DDE Messages from HomeVision"
      Height          =   2895
      Left            =   240
      TabIndex        =   10
      Top             =   2280
      Width           =   5535
      Begin VB.CommandButton btnClearList 
         Caption         =   "Clear List"
         Height          =   495
         Left            =   840
         TabIndex        =   14
         Top             =   1680
         Width           =   1095
      End
      Begin VB.ListBox lstMessage 
         Height          =   1425
         Left            =   2040
         TabIndex        =   11
         Top             =   1200
         Width           =   3375
      End
      Begin VB.Label DDEMessageAcknowledge 
         Caption         =   "None sent"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   2400
         TabIndex        =   16
         Top             =   840
         Width           =   2415
      End
      Begin VB.Label Label5 
         Caption         =   "Message acknowledgement:"
         Height          =   255
         Left            =   240
         TabIndex        =   15
         Top             =   840
         Width           =   2175
      End
      Begin VB.Label Label1 
         Caption         =   "DDE Message Control:"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   13
         Top             =   480
         Width           =   1695
      End
      Begin VB.Label DDEMessage 
         Caption         =   "No message from HomeVision"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2400
         TabIndex        =   12
         Top             =   480
         Width           =   3015
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "DDE Commands to HomeVision"
      Height          =   1935
      Left            =   240
      TabIndex        =   3
      Top             =   120
      Width           =   5535
      Begin VB.TextBox txtManualCommandEntry 
         Height          =   285
         Left            =   240
         TabIndex        =   5
         Text            =   "Enter manual command here"
         Top             =   1320
         Width           =   3495
      End
      Begin VB.CommandButton btnSendCommand 
         Caption         =   "Send Command"
         Enabled         =   0   'False
         Height          =   495
         Left            =   3960
         TabIndex        =   4
         Top             =   1200
         Width           =   1335
      End
      Begin VB.Label Label3 
         Caption         =   "DDE Command Control:"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   480
         Width           =   1815
      End
      Begin VB.Label Label2 
         Caption         =   "Command acknowledgement:"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   840
         Width           =   2175
      End
      Begin VB.Label DDECommandAcknowledge 
         Caption         =   "None received"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   2520
         TabIndex        =   7
         Top             =   840
         Width           =   2895
      End
      Begin VB.Label DDECommand 
         Caption         =   "Command to send"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   2520
         TabIndex        =   6
         Top             =   480
         Width           =   2895
      End
   End
   Begin VB.CommandButton btnCloseLink 
      Caption         =   "Close Links"
      Enabled         =   0   'False
      Height          =   495
      Left            =   3360
      TabIndex        =   2
      Top             =   5400
      Width           =   1215
   End
   Begin VB.CommandButton btnOpenLink 
      Caption         =   "Open Links"
      Height          =   495
      Left            =   1440
      TabIndex        =   0
      Top             =   5400
      Width           =   1215
   End
   Begin VB.Label lblStatus 
      Caption         =   "Status Message"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   6120
      Width           =   5535
   End
End
Attribute VB_Name = "frmDDE"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Variable TRUE after sending command to HomeVision and waiting
'for acknowledgement from the HomeVision app that it was received:
Private DDE_Command_In_Process As Boolean

Private Sub btnClearList_Click()

lstMessage.Clear

End Sub

Private Sub btnCloseLink_Click()
Dim status As Integer

'Call function to open DDE links to HomeVision:
status = Close_DDE_Link

If status = 0 Then 'OK
    lblStatus = "DDE link to HomeVision closed"
Else  'ERROR
    lblStatus = "Error closing DDE link to HomeVision"
End If

btnOpenLink.Enabled = True
btnSendCommand.Enabled = False
btnCloseLink.Enabled = False

End Sub

Private Sub btnOpenLink_Click()
Dim status As Integer

'Call function to open DDE links to HomeVision:
status = Open_DDE_Link

If status = 0 Then 'OK
    lblStatus = "DDE link to HomeVision opened"
    btnSendCommand.Enabled = True
    btnCloseLink.Enabled = True
    btnOpenLink.Enabled = False
Else  'ERROR
    lblStatus = "Error opening DDE link to HomeVision"
End If

End Sub



Private Sub btnSendCommand_Click()
'This example shows taking the text from a text box and sending
'it as a DDE command to HomeVision.

Dim status As Integer

lblStatus = "Sending DDE command to HomeVision ..."

'Call function to send the desired command:
status = Send_DDE_Command(txtManualCommandEntry)

If status <> 0 Then 'ERROR
    lblStatus = "Error sending DDE command to HomeVision"
End If

End Sub













Private Sub DDECommand_LinkError(LinkErr As Integer)

lblStatus = "DDE command link error"
MsgBox "DDE command link error"

End Sub


Private Sub DDECommand_LinkNotify()
lblStatus = "Command link notify"
MsgBox "DDE command link notify"
DDECommand.LinkRequest

End Sub


Private Sub DDECommandAcknowledge_Change()
'This event occurs after HomeVision acknowledges that the
'previous command was received.

'If the command received was OK, the acknowledgement will be
'either "OK 1" or "OK 2".  Each successful command will use
'an alternate message so that this DDECommandAcknowledge_Change
'event will be triggered each time.

'Determine whether the command was executed properly or not:
If DDECommandAcknowledge = "OK 1" Or DDECommandAcknowledge = "OK 2" Then
    lblStatus = "DDE command received OK by HomeVision"
Else
    lblStatus = "DDE command received in error by HomeVision"
    'You may want to resend this command
End If

'Indicate command is complete:
DDE_Command_In_Process = False

End Sub



Private Sub DDEMessage_Change()
Dim status As Integer

'This DDEMessage_Change event occurs after the new message is received.

If DDEMessage <> "--------" Then
    lblStatus = "New DDE message received from HomeVision"
    
    'Add new message to message list box:
    If lstMessage.ListCount > 50 Then
        'only keep 50 most recent messages
        lstMessage.RemoveItem 0   'Remove earliest message from list
    End If
    lstMessage.AddItem DDEMessage
    'Highlight last message (message just received) in list box:
    lstMessage.ListIndex = lstMessage.ListCount - 1

    'Change the message value so we can receive next message,
    'even if the same as this one:
    DDEMessage = "--------"
    
    'Lastly, send OK acknowledgement to HomeVision:
    status = Send_DDE_Message_Ack
End If

End Sub

Private Sub DDEMessage_LinkError(LinkErr As Integer)
lblStatus = "DDE message link error"
MsgBox "DDE message link error"

End Sub

Private Sub DDEMessage_LinkNotify()

'HomeVision has notified us that it has a message to send, so request it:

DDEMessage.LinkRequest

End Sub

Public Function Open_DDE_Link() As Integer
Const conDDENoApp = 282  'error # if HomeVision application isn't running
Dim result
'Use this function first to open the DDE links to HomeVision

On Error GoTo ExitError

    'This link is used to poke commands to HomeVision:
    DDECommand.LinkTopic = "HOMEVIS|DDE"
    DDECommand.LinkItem = "DDECommand"
    DDECommand.LinkMode = vbLinkManual
    
    'This link is used to receive acknowledgement from HomeVision
    'that a previous poke command was received:
    DDECommandAcknowledge.LinkTopic = "HOMEVIS|DDE"
    DDECommandAcknowledge.LinkItem = "DDECommandAcknowledge"
    DDECommandAcknowledge.LinkMode = vbLinkAutomatic
   
    'This link is used to receive messages from HomeVision:
    DDEMessage.LinkTopic = "HOMEVIS|DDE"
    DDEMessage.LinkItem = "DDEMessage"
    DDEMessage.LinkMode = vbLinkAutomatic
    
    'This link is used to send an acknowledgement to HomeVision
    'that a previous message was received:
    DDEMessageAcknowledge.LinkTopic = "HOMEVIS|DDE"
    DDEMessageAcknowledge.LinkItem = "DDEMessageAcknowledge"
    DDEMessageAcknowledge.LinkMode = vbLinkManual

    Open_DDE_Link = 0   'OK
    Exit Function

ExitError:
    If Err = conDDENoApp Then
        MsgBox ("HomeVision is not running.  Please start it.")
    Else
        MsgBox ("Unknown error opening DDE link")
    End If
    
    Open_DDE_Link = -1   'ERROR

End Function

Public Function Close_DDE_Link() As Integer
'Use this function to close the DDE links to HomeVision

On Error GoTo ExitError

    DDECommand.LinkMode = vbLinkNone
    DDEMessage.LinkMode = vbLinkNone
    DDECommandAcknowledge.LinkMode = vbLinkNone
    DDEMessageAcknowledge.LinkMode = vbLinkNone
    
    Close_DDE_Link = 0 'OK
    Exit Function
    
ExitError:
    Close_DDE_Link = -1  'ERROR

End Function

Public Function Send_DDE_Command(CommandToSend As String) As Integer
'This function sends the DDE command (a text string) to HomeVision

On Error GoTo ExitError

    'First, set DDECommand label to the desired command:
    DDECommand = CommandToSend
    
    'Now poke it to HomeVision:
    DDECommand.LinkPoke

    'Indicate command sent to HomeVision and waiting for acknowledgement:
    DDE_Command_In_Process = True
    Send_DDE_Command = 0   'OK
    
    Exit Function
    
ExitError:
    Send_DDE_Command = -1   'ERROR

End Function

Public Function Send_DDE_Message_Ack() As Integer
'After receiving a message from HomeVision, use this function to
'send an acknowledgement to HomeVision

On Error GoTo ExitError
    
'Set OK acknowledgement text (alternate between "OK 1" and "OK 2"):
If DDEMessageAcknowledge <> "OK 1" Then
    DDEMessageAcknowledge = "OK 1"
Else
    DDEMessageAcknowledge = "OK 2"
End If

'Now send it to HomeVision using the LinkPoke method:
DDEMessageAcknowledge.LinkPoke

Send_DDE_Message_Ack = 0   'OK
Exit Function

ExitError:
Send_DDE_Message_Ack = -1   'ERROR

End Function



